# 160224 # extract reads to build consensus for haplotypes!

setwd("~/Documents/UNI_und_VORLESUNGEN/11 phd projects/1 Meta SCHMALNAU/2 HiSeq TierMix scripts/R scripte/Extract_haplotypes")

time <- Sys.time()

hittable_files <- c("../../7 BOLD/OTU_BF2_BR2/OTU_BF2_BR2_taxo_v5.csv")
keep_files <- c("../1 variability plot/1 PLOTS + tables/OTU_BF2_BR2_taxo_v5_adj.csv")
Fastapattern <- c("")
q <- 1


#for (q in 1:4){}

keep <- read.csv(keep_files[q], sep=",", stringsAsFactors=F)
keep <- keep[-c(1,3)]
keep <- cbind(keep[1], keep[2:11]>=0.003) # stuff above 0.003, get sequences


hittable <- read.csv(hittable_files[q], stringsAsFactors=F)
hittable <- hittable[-13]

hittable_OTU <- as.numeric(sub("OTU_", "", hittable$ID))


ID_rep <- c( "B", "d", "A", "c", "E", "F", "g", "H", "i", "j")

files <- list.files("/Volumes/NGS 750 GB/9 BLAST/", pattern=".*.txt") # usearch hit tables
files <- files[c(12,14,16,18,20, 32,34,36,38,40)] # BF2_BR2
files <- files[c(6,5,7,9,3,1,10,2,4,8)]


sequfiles <- list.files("/Volumes/NGS 750 GB/7 revcomp/", pattern=".txt")
sequfiles <- sequfiles[c(12,14,16,18,20, 32,34,36,38,40)] # BF2_BR2
sequfiles <- sequfiles[c(6,5,7,9,3,1,10,2,4,8)]

#cbind(files, names(keep)[-c(1:3)], sequfiles)

i <- 1

for(i in 1:10){
# read hit table
hits <- read.csv(paste("/Volumes/NGS 750 GB/9 BLAST/", files[i], sep=""), sep="\t", header=F)
hits$V2 <- as.numeric(gsub("OTU_(.*);size.*", "\\1", hits$V2))
hits$V12 <- as.numeric(gsub(".*size=(.*);.*", "\\1", hits$V1))

#read fasta file! double_v1.R

rawdata <- readLines(paste("/Volumes/NGS 750 GB/7 revcomp/", sequfiles[i], sep="")) #replica I
head(rawdata)
delimit <- grep(">", rawdata) # detect >
delimit <- c(delimit, length(rawdata)+1)
ID <- sub(">", "", rawdata[delimit])
sequ1 <- c(1:length(delimit))
for (x in 1:(length(delimit)-1)){
sequ1[x] <- paste(rawdata[(delimit[x]+1):((delimit[x+1])-1)], collapse="") # rowlength 7
}

sequ <- data.frame(ID, sequ=sequ1, stringsAsFactors = FALSE)

head(sequ)
head(hittable)

head(hits)


# loop subsetting sequences for exporting
for (k in 1:52){
if (keep[keep$X==k,i+2]){
getotu <- hittable_OTU[hittable$ID.1==k] # id of taxa to OTU hit id
temp <- hits[hits$V2%in%getotu,] # subset hits with OTUs tax i
temp <- temp[temp$V12==max(temp$V12),] # highest hit! most abund

outID <- paste(">", k, "_", ID_rep[i], "_",temp$V12, "_", hittable$Taxon[hittable$ID.1==k][1], sep="")

cat(outID, file="sequ.fasta", append=T, sep="\n")
cat(sequ$sequ[sequ$ID==temp$V1], file="sequ.fasta", append=T, sep="\n")
}
}
print(Sys.time()-time)
time <- Sys.time()
}

length(sequ$ID)
length(temp$V1)

